#include "global.h"

struct Global g;

Global::Global()
{
	screen = 0;

	time = 0;
	frame_time = 10;

	scr_height = 750;
	scr_width = scr_height*2;
	fullscreen = false;
    running = true;
	draw_contours = true;

	method = Method::lines_linear;
	deriv = 1;
	alpha = 2;

	N = 8;
	deformation.resize((N+1)*(N+1));

	draw_grid = false;
	draw_image = true;
	draw_surface = true;
	use_basis_values = false;

	sel_type = 1;
	sel_vert = 0;
	height_scale = .4;
}

vect3d Global::surf(int x, int y)
{
	int n = g.poly[0].size();
	double h = 0;

	double *bary = &g.barycoords[((y*(g.N+1))+x)*n];
	//double h = 0;
	//for (int i = 0; i < n; i++)
	//	h += g.height_vals[i]*bary[i];
	if (g.deriv = 0)
		h = bary[g.sel_vert];
	else if (g.barycoords2.size() == g.barycoords.size())
	{
		double *bary2 = &g.barycoords2[((y*(g.N+1))+x)*g.norms[0].size()*3];
		//for (int i = 0; i < n; i++)
		//	h += g.deriv_vals[i]*bary2[i];
		h = bary2[g.sel_vert * 3 + 1];
	}

	double xx = double(x)/g.N;
	double yy = double(y)/g.N;
	return vect3d(xx, yy, h * height_scale);
}
